using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Cosmos.Common;
using Cosmos.CommonManager;
using Cosmos.UserFrame;
using Cosmos.BaseFrame;

namespace Cosmos.Win
{
    public partial class frmSalCalc : Form
    {
        #region 변수 선언
        private PosStatus m_cPosStatus = new PosStatus();                           // 기본정보 참조
        private StateServer StateObject = (StateServer)StateServer.GetInstance();   // StateObject : StateServer Object (객체)

        string PreValue = string.Empty;         // 마지막 연산 이전 결과 값
        string leftValue = string.Empty;        //좌항의 값이 저장되는 문자열
        bool bPoint = false;                    // 마지막이 '.'일경우 다음에 소수를 입력 받아야할때 : true
        bool bTextClear = false;                // 연산자를 누른 후에 새로운 값을 받기위한 상태 : true
        bool bContinuityOperation = false;      // 사칙연산버튼을 누른 경우 : true  ## 연산자를 누른 후 번호를 입력하면 : false
        string prevOp = string.Empty;           // 연산자가 저장되는 문자열
        bool bOperationStart = false;           // 좌항과 우항이 있을때 계산을 할수있는상태 : true
        string rightValue = string.Empty;       //연속 '=' 클릭시 우항의 값이 저장되는 문자열

        bool bEndModFlag = false;               // 연산 완료 후 숫자를 입력하여 마지막 숫자를 변경하였을 경우 체크 FLAG
        bool bEnterFlag = false;                // 엔터(=) 연속으로 누를 경우 자동 계산을 위한 상태 FLAG

        bool bFirst = true;                     // 처음 계산 시작인지 체크 FLAG

        // 임시 시작
        bool EE_FLAG = false;
        bool OP_FLAG = false;

        string orgValue = string.Empty;
        // 임시 끝
        #endregion 변수 선언

        #region 생성자 & 소멸자
        public frmSalCalc()
        {
            InitializeComponent();

            base.SetStyle(ControlStyles.OptimizedDoubleBuffer | ControlStyles.AllPaintingInWmPaint | ControlStyles.ResizeRedraw, true);

            m_cPosStatus = (PosStatus)StateObject.POS;      // POS 기본정보
        }

        private void frmSalCalc_Load(object sender, EventArgs e)
        {
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", "");
            // 콘트롤 초기화 처리
            InitControl();
        }

        private void frmSalCalc_FormClosing(object sender, FormClosingEventArgs e)
        {
            UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", lblTitle.Text);
        }
        #endregion 생성자 & 소멸자

        #region 폼 컨트롤 초기화
        private void InitControl()
        {
            try
            {

                FormManager.SetFormAllControlFont(this, m_cPosStatus.Base.FONT);
                FormManager.SetTextBoxGlobalInfo(this, m_cPosStatus.Global.m_stCultureMaster.nGroupingDigits, m_cPosStatus.Global.m_stCultureMaster.strGroupingSymbol
                        , m_cPosStatus.Global.m_stCultureMaster.nDecimalDigits, m_cPosStatus.Global.m_stCultureMaster.strDecimalSymbol);

                picBack.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.POP_SIZE_S);

                btnExit.Image = ImageManager.GetImage(BaseCom.NxImgPath, ImageManager.BTN_CLOSE);
                if (btnExit.Image != null) btnExit.Text = "";

                // 라벨 이름 설정
                lblTitle.Text = MessageManager.GetLabelMessage(POS_MESSAGE.LABEL.MSG_0340);

                bFirst = true;                     // 처음 계산 시작인지 체크 FLAG

                leftValue = string.Empty;          //좌항의 값이 저장되는 문자열
                bPoint = false;                    // 마지막이 '.'일경우 다음에 소수를 입력 받아야할때 : true
                bTextClear = false;                // 연산자를 누른 후에 새로운 값을 받기위한 상태 : true
                bContinuityOperation = false;      // 사칙연산버튼을 누른 경우 : true  ## 연산자를 누른 후 번호를 입력하면 : false
                prevOp = string.Empty;             // 연산자가 저장되는 문자열
                bOperationStart = false;           // 좌항과 우항이 있을때 계산을 할수있는상태 : true
                rightValue = string.Empty;

                bEndModFlag = false;               // 연산 완료 후 연산자가 아닌 숫자를 입력하여 마지막 숫자를 변경하였을 경우 체크 FLAG
                bEnterFlag = false;                // 엔터(=) 연속으로 누를 경우 자동 계산을 위한 상태 FLAG

                txtInputNum.Text = "0";
                txtCalc.Text = "";
                txtResult.Text = "0";

                txtInputNum.Select();
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
        }
        #endregion 폼 컨트롤 초기화

        #region Control Event
        private void btnExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            InitControl();
        }

        // 0~9 숫자 입력 버튼
        private void btn_NumPadClick(object sender, EventArgs e)
        {
            AppendNumber(((UI.CsmButton)sender).Text);
        }

        // + - * / 사칙연산을 클릭 이벤트
        private void btnOper_Click(object sender, EventArgs e)
        {
            OperationCalc(((UI.CsmButton)sender).Text);
        }

        private void btnEnter_Click(object sender, EventArgs e)
        {
            try
            {

                if (prevOp != string.Empty)
                {
                    rightValue = txtInputNum.Text; // 현재텍스트박스의 값을 우항의 값에 넣는다. 연속으로 'ENTER' 버튼을 누를때 사용한다.
                    
                    if (OP_FLAG == true)
                    {
                        orgValue = txtResult.Text;
                    }

                    if (bEnterFlag == false)
                    {
                        if (UsUtil.ChkIsNum(txtCalc.Text[txtCalc.Text.Length - 1].ToString()) != true)
                        {
                            // 끝이 숫자가 아니라면 그냥 끝에 현재 입력되어 있는 숫자만 붙이고
                            txtCalc.Text += txtInputNum.Text;
                        }
                        else
                        {
                            // 끝이 숫자라면 마지막 입력한 사칙연산 +  현재 입력되어 있는 숫자를 붙인다.
                            txtCalc.Text += prevOp + txtInputNum.Text;
                            leftValue = txtResult.Text;
                        }
                    }

                    switch (prevOp)
                    {
                        case "+": txtResult.Text = Plus(leftValue, rightValue); break;
                        case "-": txtResult.Text = Minus(leftValue, rightValue); break;
                        case "*": txtResult.Text = Multiply(leftValue, rightValue); break;
                        case "/": txtResult.Text = Div(leftValue, rightValue); break;
                    }
                    bEnterFlag = false;

                    EE_FLAG = true;
                    OP_FLAG = false;
                }
                //leftValue = txtResult.Text;

                // 테스트
                // 연산 끝난 뒤 숫자 입력창의 초기화를 시켜주지 않기 위하여 
                //bTextClear = true;

                bOperationStart = false;
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
        }

        private void btnDot_Click(object sender, EventArgs e)
        {
            try
            {

                bEnterFlag = true;

                if (txtInputNum.Text.Length > 0 && txtInputNum.Text[txtInputNum.Text.Length - 1] == '.')
                {
                    bPoint = true;
                }
                else
                {
                    // 입력값이 비어 있을 경우 0.을 만들어 준다.
                    if (txtInputNum.Text == "")
                    {
                        txtInputNum.Text = "0.";
                        //bPoint = true;
                    }
                    else
                    {
                        // 아닐 경우 마지막에 점을 찍어준다.
                        txtInputNum.Text += ".";
                        //bPoint = true;
                    }

                    if (txtCalc.Text == "")
                    {
                        txtCalc.Text = "0.";
                    }
                    else
                    {
                        // 아닐 경우 마지막에 점을 찍어준다.
                        txtCalc.Text += ".";
                    }

                    bPoint = true;
                }
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
        }
        #endregion Control Event

        #region User Method
        /// <summary>
        /// 텍스트박스에 입력한 숫자를 추가한다.
        /// txtClear가 true 거나 입력되어있는 숫자가 0이라면  기존 txtView를 지운 다음 추가한다.
        /// </summary>
        /// <param name="str">입력한 숫자</param>
        private void AppendNumber(string str)
        {
            try
            {

                bEnterFlag = true;

                if (EE_FLAG == true)
                {
                    leftValue = orgValue;
                }

                if (bTextClear)
                {
                    txtInputNum.Text = "0";
                    bTextClear = false;
                    bContinuityOperation = false;
                }
                // 25자 이상이면 리턴한다.
                if (txtInputNum.Text.Length >= 25)
                    return;
                // 소수거나 0. 다음에 소수점을 입력할 경우에 그냥 추가한다.
                if (txtInputNum.Text[txtInputNum.Text.Length - 1] != '0' || bPoint)
                {
                    if (bPoint)
                        bPoint = false;

                    txtInputNum.AppendText(str);
                    txtCalc.AppendText(str);

                }
                else
                {
                    if (txtInputNum.Text.Equals("0"))
                    {
                        txtInputNum.Text = "";
                    }
                    txtInputNum.AppendText(str);
                    txtCalc.AppendText(str);
                }

                if (bOperationStart == true)
                {
                    bEndModFlag = true;
                }

                // 처음만 입력값을 결과값에 복사해 놓는다.
                if (bFirst == true)
                {
                    txtResult.Text = txtInputNum.Text;
                }
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
        }

        /// <summary>
        /// op 연산자를 받아서 해당 연산을 한다.
        /// </summary>
        /// <param name="op">op: 수행할 연산자</param>
        private void OperationCalc(string op)
        {
            try
            {
                bFirst = false;
                bEndModFlag = false;
                bEnterFlag = false;

                leftValue = txtResult.Text;
                EE_FLAG = false;
                OP_FLAG = true;

                // 연산자를 두번 눌렀다면 
                if (bContinuityOperation)
                {
                    if (prevOp != op)
                    {
                        string sOrgCalc = txtCalc.Text.Trim();
                        txtCalc.Text = "";
                        // 전에 입력한 연산자와 지금 누른 연산자가 다르다면 지금 누른 연산자로 교체한다.
                        txtCalc.Text = sOrgCalc.Remove(sOrgCalc.Length - 1, 1);
                        sOrgCalc = txtCalc.Text.Trim();
                        txtCalc.Text = sOrgCalc.Insert(sOrgCalc.Length, op);
                    }
                    prevOp = op;
                    return;
                }

                if (bOperationStart)
                {
                    switch (prevOp)
                    {
                        case "+": txtResult.Text = Plus(leftValue, txtInputNum.Text); break;
                        case "-": txtResult.Text = Minus(leftValue, txtInputNum.Text); break;
                        case "*": txtResult.Text = Multiply(leftValue, txtInputNum.Text); break;
                        case "/": txtResult.Text = Div(leftValue, txtInputNum.Text); break;
                    }
                }
                else bOperationStart = true;

                leftValue = txtResult.Text;
                prevOp = op;
                txtCalc.Text += op;
                bTextClear = true;
                bContinuityOperation = true; // 연산자를 누르면 true 고 다음번에 숫자를 누르면 false로 변경된다.
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
            }
        }

        // 사칙연산 함수
        // 더하기
        private string Plus(string leftValue, string rightValue)
        {
            try
            {
                return (double.Parse(leftValue) + double.Parse(rightValue)).ToString();
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
                return "0";
            }
        }
        //빼기
        private string Minus(string leftValue, string rightValue)
        {
            try
            {
                return (double.Parse(leftValue) - double.Parse(rightValue)).ToString();
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
                return "0";
            }
        }
        //곱하기
        private string Multiply(string leftValue, string rightValue)
        {
            try
            {
                return (double.Parse(leftValue) * double.Parse(rightValue)).ToString();
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
                return "0";
            }
        }
        //나누기
        private string Div(string leftValue, string rightValue)
        {
            try
            {
                // 두값중 하나가 0 이라면 "0"을 리턴한다.
                double dleftValue = double.Parse(leftValue);
                double drightValue = double.Parse(rightValue);
                if (dleftValue == 0 || drightValue == 0)
                    return "0";
                return (dleftValue / drightValue).ToString();
            }
            catch (Exception ex)
            {
                UserLog.WriteLogFile(UserCom.LOG_ERROR,
                                     System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,      // Project Name (프로젝트명)
                                     System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." +  // Class Name (Class Name (클래스명))
                                     System.Reflection.MethodBase.GetCurrentMethod().Name + "()",                // Function Name (Function Name (함수명))
                                     ex.Message);
                return "0";
            }
        }
        #endregion User Method

    }
}
